diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/applications/model/udp-trace-client.h ns-3.41/src/applications/model/udp-trace-client.h
--- ns-3.40/src/applications/model/udp-trace-client.h	2023-09-27 13:30:37.614839000 -0700
+++ ns-3.41/src/applications/model/udp-trace-client.h	2024-02-09 14:44:07.857789800 -0800
@@ -41,7 +41,7 @@
  *
  * Sends UDP packets based on a trace file of a MPEG4 stream.
  * Trace files can be downloaded from:
- * http://trace.eas.asu.edu/mpeg4/index.html
+ * https://web.archive.org/web/20210113211420/http://trace.eas.asu.edu/mpeg4/index.html
  * (the 2 first lines of the file should be removed) A valid trace file is a file with 4 columns:
  * \li -1- the first one represents the frame index
  * \li -2- the second one indicates the type of the frame: I, P or B
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/applications/test/udp-client-server-test.cc ns-3.41/src/applications/test/udp-client-server-test.cc
--- ns-3.40/src/applications/test/udp-client-server-test.cc	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/applications/test/udp-client-server-test.cc	2024-02-09 14:44:07.857789800 -0800
@@ -31,6 +31,7 @@
 #include "ns3/test.h"
 #include "ns3/udp-client-server-helper.h"
 #include "ns3/udp-echo-helper.h"
+#include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 
 #include <fstream>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/bridge/CMakeLists.txt ns-3.41/src/bridge/CMakeLists.txt
--- ns-3.40/src/bridge/CMakeLists.txt	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/bridge/CMakeLists.txt	2024-02-09 14:44:07.857789800 -0800
@@ -9,5 +9,4 @@
     model/bridge-channel.h
     model/bridge-net-device.h
   LIBRARIES_TO_LINK ${libnetwork}
-  TEST_SOURCES ${test_sources}
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/bridge/examples/csma-bridge.py ns-3.41/src/bridge/examples/csma-bridge.py
--- ns-3.40/src/bridge/examples/csma-bridge.py	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/bridge/examples/csma-bridge.py	2024-02-09 14:44:07.857789800 -0800
@@ -1,17 +1,17 @@
-# /*
-#  * This program is free software; you can redistribute it and/or modify
-#  * it under the terms of the GNU General Public License version 2 as
-#  * published by the Free Software Foundation
-#  *
-#  * This program is distributed in the hope that it will be useful,
-#  * but WITHOUT ANY WARRANTY; without even the implied warranty of
-#  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#  * GNU General Public License for more details.
-#  *
-#  * You should have received a copy of the GNU General Public License
-#  * along with this program; if not, write to the Free Software
-#  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#  */
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 2 as
+# published by the Free Software Foundation
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
 
 # Network topology
 #
@@ -32,12 +32,18 @@
 #  \ingroup bridge
 #  Bridge example connecting two broadcast domains.
 
-
-from ns import ns
+## Import ns-3
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 
 
 def main(argv):
-
     #
     # Allow the user to override any of the defaults and the above Bind() at
     # run-time, via command-line arguments
@@ -48,14 +54,14 @@
     #
     # Explicitly create the nodes required by the topology(shown above).
     #
-    #print "Create nodes."
+    # print "Create nodes."
     terminals = ns.network.NodeContainer()
     terminals.Create(4)
 
     csmaSwitch = ns.network.NodeContainer()
     csmaSwitch.Create(1)
 
-    #print "Build Topology"
+    # print "Build Topology"
     csma = ns.csma.CsmaHelper()
     csma.SetChannelAttribute("DataRate", ns.network.DataRateValue(ns.network.DataRate(5000000)))
     csma.SetChannelAttribute("Delay", ns.core.TimeValue(ns.core.MilliSeconds(2)))
@@ -66,7 +72,9 @@
     switchDevices = ns.network.NetDeviceContainer()
 
     for i in range(4):
-        link = csma.Install(ns.network.NodeContainer(ns.network.NodeContainer(terminals.Get(i)), csmaSwitch))
+        link = csma.Install(
+            ns.network.NodeContainer(ns.network.NodeContainer(terminals.Get(i)), csmaSwitch)
+        )
         terminalDevices.Add(link.Get(0))
         switchDevices.Add(link.Get(1))
 
@@ -84,7 +92,7 @@
 
     # We've got the "hardware" in place.  Now we need to add IP addresses.
     #
-    #print "Assign IP Addresses."
+    # print "Assign IP Addresses."
     ipv4 = ns.internet.Ipv4AddressHelper()
     ipv4.SetBase(ns.network.Ipv4Address("10.1.1.0"), ns.network.Ipv4Mask("255.255.255.0"))
     ipv4.Assign(terminalDevices)
@@ -92,12 +100,12 @@
     #
     # Create an OnOff application to send UDP datagrams from node zero to node 1.
     #
-    #print "Create Applications."
-    port = 9   # Discard port(RFC 863)
+    # print "Create Applications."
+    port = 9  # Discard port(RFC 863)
 
     inet_sock_address = ns.network.InetSocketAddress(ns.network.Ipv4Address("10.1.1.2"), port)
     onoff = ns.applications.OnOffHelper("ns3::UdpSocketFactory", inet_sock_address.ConvertTo())
-    onoff.SetConstantRate (ns.network.DataRate ("500kb/s"))
+    onoff.SetConstantRate(ns.network.DataRate("500kb/s"))
 
     app = onoff.Install(ns.network.NodeContainer(terminals.Get(0)))
     # Start the application
@@ -114,8 +122,7 @@
     # Create a similar flow from n3 to n0, starting at time 1.1 seconds
     #
     inet_address = ns.network.InetSocketAddress(ns.network.Ipv4Address("10.1.1.1"), port)
-    onoff.SetAttribute("Remote",
-                       ns.network.AddressValue(inet_address.ConvertTo()))
+    onoff.SetAttribute("Remote", ns.network.AddressValue(inet_address.ConvertTo()))
     app = onoff.Install(ns.network.NodeContainer(terminals.Get(3)))
     app.Start(ns.core.Seconds(1.1))
     app.Stop(ns.core.Seconds(10.0))
@@ -127,9 +134,9 @@
     # Configure tracing of all enqueue, dequeue, and NetDevice receive events.
     # Trace output will be sent to the file "csma-bridge.tr"
     #
-    #print "Configure Tracing."
-    #ascii = ns.network.AsciiTraceHelper();
-    #csma.EnableAsciiAll(ascii.CreateFileStream ("csma-bridge.tr"));
+    # print "Configure Tracing."
+    # ascii = ns.network.AsciiTraceHelper();
+    # csma.EnableAsciiAll(ascii.CreateFileStream ("csma-bridge.tr"));
 
     #
     # Also configure some tcpdump traces; each interface will be traced.
@@ -143,14 +150,13 @@
     #
     # Now, do the actual simulation.
     #
-    #print "Run Simulation."
+    # print "Run Simulation."
     ns.core.Simulator.Run()
     ns.core.Simulator.Destroy()
-    #print "Done."
-
+    # print "Done."
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     import sys
-    main(sys.argv)
 
+    main(sys.argv)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/brite/CMakeLists.txt ns-3.41/src/brite/CMakeLists.txt
--- ns-3.40/src/brite/CMakeLists.txt	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/brite/CMakeLists.txt	2024-02-09 14:44:07.861789700 -0800
@@ -14,6 +14,7 @@
   HEADER_NAME Brite.h
   LIBRARY_NAME brite
   SEARCH_PATHS ${NS3_WITH_BRITE}
+  OUTPUT_VARIABLE "NS3_BRITE_REASON"
 )
 
 if((NOT
@@ -49,9 +50,7 @@
   SOURCE_FILES helper/brite-topology-helper.cc
   HEADER_FILES helper/brite-topology-helper.h
   LIBRARIES_TO_LINK
-    ${libnetwork}
-    ${libcore}
-    ${libinternet}
+    ${libapplications}
     ${libpoint-to-point}
     ${brite_LIBRARIES}
   TEST_SOURCES test/brite-test-topology.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/brite/examples/brite-generic-example.py ns-3.41/src/brite/examples/brite-generic-example.py
--- ns-3.40/src/brite/examples/brite-generic-example.py	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/brite/examples/brite-generic-example.py	2024-02-09 14:44:07.861789700 -0800
@@ -18,7 +18,14 @@
 # Modified by: Gabriel Ferreira <gabrielcarvfer@gmail.com>
 #
 
-from ns import ns
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 
 ns.LogComponentEnable("BriteTopologyHelper", ns.LOG_LEVEL_ALL)
 
@@ -88,7 +95,7 @@
 
 echoClient = ns.UdpEchoClientHelper(serverInterfaces.GetAddress(0).ConvertTo(), 9)
 echoClient.SetAttribute("MaxPackets", ns.UintegerValue(1))
-echoClient.SetAttribute("Interval", ns.TimeValue(ns.Seconds(1.)))
+echoClient.SetAttribute("Interval", ns.TimeValue(ns.Seconds(1.0)))
 echoClient.SetAttribute("PacketSize", ns.UintegerValue(1024))
 
 clientApps = echoClient.Install(client.Get(0))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/brite/helper/brite-topology-helper.h ns-3.41/src/brite/helper/brite-topology-helper.h
--- ns-3.40/src/brite/helper/brite-topology-helper.h	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/brite/helper/brite-topology-helper.h	2024-02-09 14:44:07.861789700 -0800
@@ -32,7 +32,7 @@
 // here we just need a forward declaration.
 namespace brite
 {
-struct Topology;
+class Topology;
 };
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/buildings/CMakeLists.txt ns-3.41/src/buildings/CMakeLists.txt
--- ns-3.40/src/buildings/CMakeLists.txt	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/buildings/CMakeLists.txt	2024-02-09 14:44:07.861789700 -0800
@@ -30,8 +30,7 @@
     model/oh-buildings-propagation-loss-model.h
     model/random-walk-2d-outdoor-mobility-model.h
     model/three-gpp-v2v-channel-condition-model.h
-  LIBRARIES_TO_LINK ${libmobility}
-                    ${libpropagation}
+  LIBRARIES_TO_LINK ${libpropagation}
   TEST_SOURCES
     test/buildings-channel-condition-model-test.cc
     test/buildings-helper-test.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/buildings/doc/source/conf.py ns-3.41/src/buildings/doc/source/conf.py
--- ns-3.40/src/buildings/doc/source/conf.py	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/buildings/doc/source/conf.py	2024-02-09 14:44:07.861789700 -0800
@@ -11,206 +11,209 @@
 # All configuration values have a default; values that are commented out
 # serve to show the default.
 
-import sys, os
+import os
+import sys
 
 # If extensions (or modules to document with autodoc) are in another directory,
 # add these directories to sys.path here. If the directory is relative to the
 # documentation root, use os.path.abspath to make it absolute, like shown here.
-#sys.path.insert(0, os.path.abspath('.'))
+# sys.path.insert(0, os.path.abspath('.'))
 
 # -- General configuration -----------------------------------------------------
 
 # If your documentation needs a minimal Sphinx version, state it here.
-#needs_sphinx = '1.0'
+# needs_sphinx = '1.0'
 
 # Add any Sphinx extension module names here, as strings. They can be extensions
 # coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
-extensions = ['sphinx.ext.imgmath',
-              'sphinxcontrib.seqdiag']
+extensions = ["sphinx.ext.imgmath", "sphinxcontrib.seqdiag"]
 
 # Add any paths that contain templates here, relative to this directory.
-templates_path = ['_templates']
+templates_path = ["_templates"]
 
 # The suffix of source filenames.
-source_suffix = '.rst'
+source_suffix = ".rst"
 
 # The encoding of source files.
-#source_encoding = 'utf-8-sig'
+# source_encoding = 'utf-8-sig'
 
 # The master toctree document.
-master_doc = 'buildings'
+master_doc = "buildings"
 
 # General information about the project.
-project = u'LENA'
-copyright = u'2011-2012, CTTC'
+project = "LENA"
+copyright = "2011-2012, CTTC"
 
 # The version info for the project you're documenting, acts as replacement for
 # |version| and |release|, also used in various other places throughout the
 # built documents.
 #
 # The short X.Y version.
-version = 'M2'
+version = "M2"
 # The full version, including alpha/beta/rc tags.
-release = 'M2'
+release = "M2"
 
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
-#language = None
+# language = None
 
 # There are two options for replacing |today|: either, you set today to some
 # non-false value, then it is used:
-#today = ''
+# today = ''
 # Else, today_fmt is used as the format for a strftime call.
-#today_fmt = '%B %d, %Y'
+# today_fmt = '%B %d, %Y'
 
 # List of patterns, relative to source directory, that match files and
 # directories to ignore when looking for source files.
 exclude_patterns = []
 
 # The reST default role (used for this markup: `text`) to use for all documents.
-#default_role = None
+# default_role = None
 
 # If true, '()' will be appended to :func: etc. cross-reference text.
-#add_function_parentheses = True
+# add_function_parentheses = True
 
 # If true, the current module name will be prepended to all description
 # unit titles (such as .. function::).
-#add_module_names = True
+# add_module_names = True
 
 # If true, sectionauthor and moduleauthor directives will be shown in the
 # output. They are ignored by default.
-#show_authors = False
+# show_authors = False
 
 # The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
+pygments_style = "sphinx"
 
 # A list of ignored prefixes for module index sorting.
-#modindex_common_prefix = []
+# modindex_common_prefix = []
 
 
 # -- Options for HTML output ---------------------------------------------------
 
 # The theme to use for HTML and HTML Help pages.  See the documentation for
 # a list of builtin themes.
-html_theme = 'default'
+html_theme = "default"
 
 # Theme options are theme-specific and customize the look and feel of a theme
 # further.  For a list of options available for each theme, see the
 # documentation.
-#html_theme_options = {}
+# html_theme_options = {}
 
 # Add any paths that contain custom themes here, relative to this directory.
-#html_theme_path = []
+# html_theme_path = []
 
 # The name for this set of Sphinx documents.  If None, it defaults to
 # "<project> v<release> documentation".
-#html_title = None
+# html_title = None
 
 # A shorter title for the navigation bar.  Default is the same as html_title.
-#html_short_title = None
+# html_short_title = None
 
 # The name of an image file (relative to this directory) to place at the top
 # of the sidebar.
-#html_logo = None
+# html_logo = None
 
 # The name of an image file (within the static path) to use as favicon of the
 # docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
 # pixels large.
-#html_favicon = None
+# html_favicon = None
 
 # Add any paths that contain custom static files (such as style sheets) here,
 # relative to this directory. They are copied after the builtin static files,
 # so a file named "default.css" will overwrite the builtin "default.css".
-#html_static_path = ['_static']
+# html_static_path = ['_static']
 
 # If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
 # using the given strftime format.
-#html_last_updated_fmt = '%b %d, %Y'
+# html_last_updated_fmt = '%b %d, %Y'
 
 # If true, SmartyPants will be used to convert quotes and dashes to
 # typographically correct entities.
-#html_use_smartypants = True
+# html_use_smartypants = True
 
 # Custom sidebar templates, maps document names to template names.
-#html_sidebars = {}
+# html_sidebars = {}
 
 # Additional templates that should be rendered to pages, maps page names to
 # template names.
-#html_additional_pages = {}
+# html_additional_pages = {}
 
 # If false, no module index is generated.
-#html_domain_indices = True
+# html_domain_indices = True
 
 # If false, no index is generated.
-#html_use_index = True
+# html_use_index = True
 
 # If true, the index is split into individual pages for each letter.
-#html_split_index = False
+# html_split_index = False
 
 # If true, links to the reST sources are added to the pages.
-#html_show_sourcelink = True
+# html_show_sourcelink = True
 
 # If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
-#html_show_sphinx = True
+# html_show_sphinx = True
 
 # If true, "(C) Copyright ..." is shown in the HTML footer. Default is True.
-#html_show_copyright = True
+# html_show_copyright = True
 
 # If true, an OpenSearch description file will be output, and all pages will
 # contain a <link> tag referring to it.  The value of this option must be the
 # base URL from which the finished HTML is served.
-#html_use_opensearch = ''
+# html_use_opensearch = ''
 
 # This is the file name suffix for HTML files (e.g. ".xhtml").
-#html_file_suffix = None
+# html_file_suffix = None
 
 # Output file base name for HTML help builder.
-#htmlhelp_basename = 'ns-3doc'
+# htmlhelp_basename = 'ns-3doc'
 
 
 # -- Options for LaTeX output --------------------------------------------------
 
 # The paper size ('letter' or 'a4').
-#latex_paper_size = 'letter'
+# latex_paper_size = 'letter'
 
 # The font size ('10pt', '11pt' or '12pt').
-#latex_font_size = '10pt'
+# latex_font_size = '10pt'
 
 # Grouping the document tree into LaTeX files. List of tuples
 # (source start file, target name, title, author, documentclass [howto/manual]).
 latex_documents = [
-  ('buildings', 'buildings.tex', u'Buildings Module Documentation', u'Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)', 'manual'),
+    (
+        "buildings",
+        "buildings.tex",
+        "Buildings Module Documentation",
+        "Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)",
+        "manual",
+    ),
 ]
 
 # The name of an image file (relative to this directory) to place at the top of
 # the title page.
-#latex_logo = None
+# latex_logo = None
 
 # For "manual" documents, if this is true, then toplevel headings are parts,
 # not chapters.
-#latex_use_parts = False
+# latex_use_parts = False
 
 # If true, show page references after internal links.
-#latex_show_pagerefs = False
+# latex_show_pagerefs = False
 
 # If true, show URL addresses after external links.
-#latex_show_urls = False
+# latex_show_urls = False
 
 # Additional stuff for the LaTeX preamble.
-#latex_preamble = ''
+# latex_preamble = ''
 
 # Documents to append as an appendix to all manuals.
-#latex_appendices = []
+# latex_appendices = []
 
 # If false, no module index is generated.
-#latex_domain_indices = True
+# latex_domain_indices = True
 
 
 # -- Options for manual page output --------------------------------------------
 
 # One entry per manual page. List of tuples
 # (source start file, name, description, authors, manual section).
-man_pages = [
-    ('index', 'ns-3-model-library', u'ns-3 Model Library',
-     [u'ns-3 project'], 1)
-]
+man_pages = [("index", "ns-3-model-library", "ns-3 Model Library", ["ns-3 project"], 1)]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/buildings/helper/building-allocator.cc ns-3.41/src/buildings/helper/building-allocator.cc
--- ns-3.40/src/buildings/helper/building-allocator.cc	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/buildings/helper/building-allocator.cc	2024-02-09 14:44:07.861789700 -0800
@@ -99,7 +99,8 @@
             .AddAttribute("LayoutType",
                           "The type of layout.",
                           EnumValue(GridPositionAllocator::ROW_FIRST),
-                          MakeEnumAccessor(&GridBuildingAllocator::m_layoutType),
+                          MakeEnumAccessor<GridPositionAllocator::LayoutType>(
+                              &GridBuildingAllocator::m_layoutType),
                           MakeEnumChecker(GridPositionAllocator::ROW_FIRST,
                                           "RowFirst",
                                           GridPositionAllocator::COLUMN_FIRST,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/buildings/model/building.cc ns-3.41/src/buildings/model/building.cc
--- ns-3.40/src/buildings/model/building.cc	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/buildings/model/building.cc	2024-02-09 14:44:07.861789700 -0800
@@ -73,7 +73,8 @@
             .AddAttribute("Type",
                           "The type of building",
                           EnumValue(Building::Residential),
-                          MakeEnumAccessor(&Building::GetBuildingType, &Building::SetBuildingType),
+                          MakeEnumAccessor<BuildingType_t>(&Building::GetBuildingType,
+                                                           &Building::SetBuildingType),
                           MakeEnumChecker(Building::Residential,
                                           "Residential",
                                           Building::Office,
@@ -83,7 +84,8 @@
             .AddAttribute("ExternalWallsType",
                           "The type of material of which the external walls are made",
                           EnumValue(Building::ConcreteWithWindows),
-                          MakeEnumAccessor(&Building::GetExtWallsType, &Building::SetExtWallsType),
+                          MakeEnumAccessor<ExtWallsType_t>(&Building::GetExtWallsType,
+                                                           &Building::SetExtWallsType),
                           MakeEnumChecker(Building::Wood,
                                           "Wood",
                                           Building::ConcreteWithWindows,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/buildings/model/buildings-propagation-loss-model.cc ns-3.41/src/buildings/model/buildings-propagation-loss-model.cc
--- ns-3.40/src/buildings/model/buildings-propagation-loss-model.cc	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/buildings/model/buildings-propagation-loss-model.cc	2024-02-09 14:44:07.861789700 -0800
@@ -54,7 +54,7 @@
 double
 BuildingsPropagationLossModel::ShadowingLoss::GetLoss() const
 {
-    return (m_shadowingValue);
+    return m_shadowingValue;
 }
 
 Ptr<MobilityModel>
@@ -130,7 +130,7 @@
     {
         loss = 12;
     }
-    return (loss);
+    return loss;
 }
 
 double
@@ -140,7 +140,7 @@
 
     int nfloors = node->GetFloorNumber() - 1;
     loss = -2 * (nfloors);
-    return (loss);
+    return loss;
 }
 
 double
@@ -166,7 +166,7 @@
         auto bit = ait->second.find(b);
         if (bit != ait->second.end())
         {
-            return (bit->second.GetLoss());
+            return bit->second.GetLoss();
         }
         else
         {
@@ -175,7 +175,7 @@
             // sigma is standard deviation, not variance
             double shadowingValue = m_randVariable->GetValue(0.0, (sigma * sigma));
             ait->second[b] = ShadowingLoss(shadowingValue, b);
-            return (ait->second[b].GetLoss());
+            return ait->second[b].GetLoss();
         }
     }
     else
@@ -185,7 +185,7 @@
         // sigma is standard deviation, not variance
         double shadowingValue = m_randVariable->GetValue(0.0, (sigma * sigma));
         m_shadowingLossMap[a][b] = ShadowingLoss(shadowingValue, b);
-        return (m_shadowingLossMap[a][b].GetLoss());
+        return m_shadowingLossMap[a][b].GetLoss();
     }
 }
 
@@ -200,24 +200,24 @@
     {
         if (!isBIndoor) // b is outdoor
         {
-            return (m_shadowingSigmaOutdoor);
+            return m_shadowingSigmaOutdoor;
         }
         else
         {
             double sigma = std::sqrt((m_shadowingSigmaOutdoor * m_shadowingSigmaOutdoor) +
                                      (m_shadowingSigmaExtWalls * m_shadowingSigmaExtWalls));
-            return (sigma);
+            return sigma;
         }
     }
     else if (isBIndoor) // b is indoor
     {
-        return (m_shadowingSigmaIndoor);
+        return m_shadowingSigmaIndoor;
     }
     else
     {
         double sigma = std::sqrt((m_shadowingSigmaOutdoor * m_shadowingSigmaOutdoor) +
                                  (m_shadowingSigmaExtWalls * m_shadowingSigmaExtWalls));
-        return (sigma);
+        return sigma;
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/buildings/model/hybrid-buildings-propagation-loss-model.cc ns-3.41/src/buildings/model/hybrid-buildings-propagation-loss-model.cc
--- ns-3.40/src/buildings/model/hybrid-buildings-propagation-loss-model.cc	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/buildings/model/hybrid-buildings-propagation-loss-model.cc	2024-02-09 14:44:07.865790000 -0800
@@ -83,7 +83,8 @@
             .AddAttribute("Environment",
                           "Environment Scenario",
                           EnumValue(UrbanEnvironment),
-                          MakeEnumAccessor(&HybridBuildingsPropagationLossModel::SetEnvironment),
+                          MakeEnumAccessor<EnvironmentType>(
+                              &HybridBuildingsPropagationLossModel::SetEnvironment),
                           MakeEnumChecker(UrbanEnvironment,
                                           "Urban",
                                           SubUrbanEnvironment,
@@ -95,7 +96,7 @@
                 "CitySize",
                 "Dimension of the city",
                 EnumValue(LargeCity),
-                MakeEnumAccessor(&HybridBuildingsPropagationLossModel::SetCitySize),
+                MakeEnumAccessor<CitySize>(&HybridBuildingsPropagationLossModel::SetCitySize),
                 MakeEnumChecker(SmallCity, "Small", MediumCity, "Medium", LargeCity, "Large"))
 
             .AddAttribute(
@@ -278,11 +279,11 @@
 {
     if (a->GetDistanceFrom(b) < m_itu1411NlosThreshold)
     {
-        return (m_ituR1411Los->GetLoss(a, b));
+        return m_ituR1411Los->GetLoss(a, b);
     }
     else
     {
-        return (m_ituR1411NlosOverRooftop->GetLoss(a, b));
+        return m_ituR1411NlosOverRooftop->GetLoss(a, b);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/buildings/model/mobility-building-info.cc ns-3.41/src/buildings/model/mobility-building-info.cc
--- ns-3.40/src/buildings/model/mobility-building-info.cc	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/buildings/model/mobility-building-info.cc	2024-02-09 14:44:07.865790000 -0800
@@ -139,28 +139,28 @@
 MobilityBuildingInfo::GetFloorNumber()
 {
     NS_LOG_FUNCTION(this);
-    return (m_nFloor);
+    return m_nFloor;
 }
 
 uint8_t
 MobilityBuildingInfo::GetRoomNumberX()
 {
     NS_LOG_FUNCTION(this);
-    return (m_roomX);
+    return m_roomX;
 }
 
 uint8_t
 MobilityBuildingInfo::GetRoomNumberY()
 {
     NS_LOG_FUNCTION(this);
-    return (m_roomY);
+    return m_roomY;
 }
 
 Ptr<Building>
 MobilityBuildingInfo::GetBuilding()
 {
     NS_LOG_FUNCTION(this);
-    return (m_myBuilding);
+    return m_myBuilding;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/buildings/model/random-walk-2d-outdoor-mobility-model.cc ns-3.41/src/buildings/model/random-walk-2d-outdoor-mobility-model.cc
--- ns-3.40/src/buildings/model/random-walk-2d-outdoor-mobility-model.cc	2023-09-27 13:30:37.618839000 -0700
+++ ns-3.41/src/buildings/model/random-walk-2d-outdoor-mobility-model.cc	2024-02-09 14:44:07.865790000 -0800
@@ -68,7 +68,7 @@
                           "The mode indicates the condition used to "
                           "change the current speed and direction",
                           EnumValue(RandomWalk2dOutdoorMobilityModel::MODE_DISTANCE),
-                          MakeEnumAccessor(&RandomWalk2dOutdoorMobilityModel::m_mode),
+                          MakeEnumAccessor<Mode>(&RandomWalk2dOutdoorMobilityModel::m_mode),
                           MakeEnumChecker(RandomWalk2dOutdoorMobilityModel::MODE_DISTANCE,
                                           "Distance",
                                           RandomWalk2dOutdoorMobilityModel::MODE_TIME,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/click/CMakeLists.txt ns-3.41/src/click/CMakeLists.txt
--- ns-3.40/src/click/CMakeLists.txt	2023-09-27 13:30:37.622839000 -0700
+++ ns-3.41/src/click/CMakeLists.txt	2024-02-09 14:44:07.865790000 -0800
@@ -17,6 +17,7 @@
   PATH_SUFFIXES userlevel
                 ns
   SEARCH_PATHS ${NS3_WITH_CLICK}
+  OUTPUT_VARIABLE "NS3_CLICK_REASON"
 )
 
 if((NOT
@@ -58,10 +59,7 @@
     helper/click-internet-stack-helper.h
     model/ipv4-click-routing.h
     model/ipv4-l3-click-protocol.h
-  LIBRARIES_TO_LINK
-    ${libcore}
-    ${libnetwork}
-    ${libinternet}
-    ${click_LIBRARIES}
+  LIBRARIES_TO_LINK ${libinternet}
+                    ${click_LIBRARIES}
   TEST_SOURCES test/ipv4-click-routing-test.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/click/examples/nsclick-simple-lan.py ns-3.41/src/click/examples/nsclick-simple-lan.py
--- ns-3.40/src/click/examples/nsclick-simple-lan.py	2023-09-27 13:30:37.622839000 -0700
+++ ns-3.41/src/click/examples/nsclick-simple-lan.py	2024-02-09 14:44:07.865790000 -0800
@@ -18,7 +18,14 @@
 
 import os.path
 
-from ns import ns
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 
 ns.LogComponentEnable("Ipv4ClickRouting", ns.LOG_LEVEL_ALL)
 ns.LogComponentEnable("Ipv4L3ClickProtocol", ns.LOG_LEVEL_ALL)
@@ -40,8 +47,9 @@
 
 # Install Click on node A
 clickinternet = ns.ClickInternetStackHelper()
-clickinternet.SetClickFile(csmaNodes.Get(0),
-                           clickConfigFolder + "/nsclick-lan-single-interface.click")
+clickinternet.SetClickFile(
+    csmaNodes.Get(0), clickConfigFolder + "/nsclick-lan-single-interface.click"
+)
 clickinternet.SetRoutingTableElement(csmaNodes.Get(0), "rt")
 clickinternet.Install(csmaNodes.Get(0))
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/click/model/ipv4-l3-click-protocol.cc ns-3.41/src/click/model/ipv4-l3-click-protocol.cc
--- ns-3.40/src/click/model/ipv4-l3-click-protocol.cc	2023-09-27 13:30:37.622839000 -0700
+++ ns-3.41/src/click/model/ipv4-l3-click-protocol.cc	2024-02-09 14:44:07.869789800 -0800
@@ -238,7 +238,7 @@
         return true;
     }
 
-    if (GetWeakEsModel()) // Check other interfaces
+    if (!GetStrongEndSystemModel()) // Check other interfaces
     {
         for (uint32_t j = 0; j < GetNInterfaces(); j++)
         {
@@ -287,13 +287,25 @@
 void
 Ipv4L3ClickProtocol::SetWeakEsModel(bool model)
 {
-    m_weakEsModel = model;
+    m_strongEndSystemModel = !model;
 }
 
 bool
 Ipv4L3ClickProtocol::GetWeakEsModel() const
 {
-    return m_weakEsModel;
+    return !m_strongEndSystemModel;
+}
+
+void
+Ipv4L3ClickProtocol::SetStrongEndSystemModel(bool model)
+{
+    m_strongEndSystemModel = model;
+}
+
+bool
+Ipv4L3ClickProtocol::GetStrongEndSystemModel() const
+{
+    return m_strongEndSystemModel;
 }
 
 Ptr<NetDevice>
